moDraw.mohPDA = {};

function moDraw.mohPDA:setOpenDraw(self, whichPDA)	
	local whichSubPDA = whichPDA or "masterPDA_";
	if moSetGetOverlays.pda[whichSubPDA] == nil or moSetGetOverlays.pda[whichSubPDA].design[1] == nil then return;end;
	moGeneralSettings.clickAreas.pda[whichSubPDA] = {};
	local horizontal = moSetGetOverlays.pda[whichSubPDA].design[5].width;
	local vertical = moSetGetOverlays.pda[whichSubPDA].design[5].height;
	local horizontalSmall = moSetGetOverlays.pda[whichSubPDA].design[5].width/2;
	local verticalSmall = moSetGetOverlays.pda[whichSubPDA].design[5].height/2;
	local posX = moSetGetOverlays.pda[whichSubPDA].manuPosX or moSetGetOverlays.pda[whichSubPDA].pos.x;
	local posY = moSetGetOverlays.pda[whichSubPDA].manuPosY or moSetGetOverlays.pda[whichSubPDA].pos.y;
	local distanceAppIconWidth = (moSetGetOverlays.pda[whichSubPDA].design[5].width-(moSetGetOverlays.buttonGfxWidth1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*8))/2;
	local distanceAppIconHeight = (moSetGetOverlays.pda[whichSubPDA].design[5].height-(moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*8))/2;	
	local horizontalTxtDistance = 0.001;
	local verticalTxtDistance = 0.001;
	local newPosX = 0;
	local newPosY = 0;
	local width = 0;
	local height = 0;
	--local viewLine = getViewLine(self);
	local viewLines = #moSetGetOverlays.pda[whichSubPDA].renderViewLines;
	local appsAtMasterLine = moSetGetOverlays.pda[whichSubPDA].viewApps; --moSetGetOverlays.pda[whichSubPDA].line[1].appsAtLine;	
	--local appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[viewLine].appsAtLine;
	
	if MultiOverlayV3.dragDropPos.on and MultiOverlayV3.dragDropPos.whatDragDrop == whichSubPDA then
		moSetGetOverlays.pda[whichSubPDA].manuPosX = MultiOverlayV3.mouseCursor.posX;
		moSetGetOverlays.pda[whichSubPDA].manuPosY = MultiOverlayV3.mouseCursor.posY+moSetGetOverlays.pda[whichSubPDA].height-verticalSmall;
	end;
	
	if not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) and moSetGetOverlays.pda[whichSubPDA].hidden.auto and not moSetGetOverlays.pda[whichSubPDA].smallView then 
		moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer = moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer+1;
		--local getTimer = tostring(moSetGetOverlays.pda[whichSubPDA].hidden.timer).. "sec"
		--if moSetGetExtras:runsTimer(getTimer) then moSetGetOverlays.pda[whichSubPDA].smallView = true;end;
		if moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer >= moGeneralSettings.timer["isTimer"..  moSetGetOverlays.pda[whichSubPDA].hidden.timer] then
			moSetGetOverlays.pda[whichSubPDA].smallView = true;
		end;
	elseif g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
		moSetGetOverlays.pda[whichSubPDA].smallView = false;
		moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer = 0;
	end;
	local isHidden = moSetGetOverlays.pda[whichSubPDA].smallView;
	if isHidden then viewLines = 0;appsAtMasterLine = 2;end;
	
	function getUpDownY(y, values, values1)
		local upDownY = 0;
		values1 = values1 or 0;
		if moSetGetOverlays.pda[whichSubPDA].pos.up and moSetGetOverlays.pda[whichSubPDA].manuPosY == nil then
			upDownY = y-values-values1;
		elseif moSetGetOverlays.pda[whichSubPDA].manuPosY ~= nil then
			if y >= 0.5 then 
				upDownY = y-values-values1;
			else
				upDownY = y+values+values1;
			end;
		elseif not moSetGetOverlays.pda[whichSubPDA].pos.up then
			upDownY = y+values+values1;		
		end;		
		return y-values-values1; --upDownY;
	end;
	
	--1=linksOben,2=mitteOben,3=rechtsOben
	--4=linksMitte,5=mitte,6=rechtsMitte
	--7=linksUnten,8=mitteUnten,9=rechtsUnten
	--10=keyAppSelect Rahmen 1 keySelect (for keyControl)
	--11=keyAppSelect Rahmen 2 settingAppSelect
	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[1], posX, posY);
	moSetGetOverlays.pda[whichSubPDA].design[1]:render();	
	width = width+(moSetGetOverlays.pda[whichSubPDA].design[1].width*2);
	height = height+(moSetGetOverlays.pda[whichSubPDA].design[1].height);
	newPosX = posX+moSetGetOverlays.pda[whichSubPDA].design[1].width;
	newPosY = getUpDownY(posY, moSetGetOverlays.pda[whichSubPDA].design[1].height);
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[3], newPosX+(horizontal*appsAtMasterLine), posY);
	moSetGetOverlays.pda[whichSubPDA].design[3]:render();
		
	for a=1, viewLines do
		height = height+moSetGetOverlays.pda[whichSubPDA].design[4].height;
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[4], posX, getUpDownY(posY, vertical*a));
		moSetGetOverlays.pda[whichSubPDA].design[4]:render();		
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[6], newPosX+(horizontal*appsAtMasterLine), getUpDownY(posY, vertical*a));
		moSetGetOverlays.pda[whichSubPDA].design[6]:render();		
	end;	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[7], posX, getUpDownY(newPosY, vertical*viewLines));
	moSetGetOverlays.pda[whichSubPDA].design[7]:render();
	if not g_currentMission.guiMenue.dragDrop.on and moGeneralSettings.setMouseCursor and not isHidden and g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then--guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], posX, getUpDownY(newPosY, vertical*viewLines));
		if not MultiOverlayV3.dragDropPos.on then
			moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], moColors.intern["green"]);			
		else
			moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], moColors.intern["red"]);			
		end;
		moSetGetOverlays.pda[whichSubPDA].design["dragDrop"]:render();
		moDraw.mohPDA:clickAreas(self, posX, posX+moSetGetOverlays.pda[whichSubPDA].design[7].width, moSetGetOverlays.pda[whichSubPDA].design[7].y, moSetGetOverlays.pda[whichSubPDA].design[7].y+(moSetGetOverlays.pda[whichSubPDA].design[7].height), "dragDrop", nil, whichSubPDA);
	end;		
	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[9], newPosX+(horizontal*appsAtMasterLine), getUpDownY(newPosY, vertical*viewLines));
	moSetGetOverlays.pda[whichSubPDA].design[9]:render();
	
	for a=1, appsAtMasterLine do
		width = width+moSetGetOverlays.pda[whichSubPDA].design[2].width;
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[2], newPosX+(horizontal*(a-1)), posY);
		moSetGetOverlays.pda[whichSubPDA].design[2]:render();		
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[8], newPosX+(horizontal*(a-1)), getUpDownY(newPosY, vertical*viewLines));
		moSetGetOverlays.pda[whichSubPDA].design[8]:render();
		for b=1, viewLines do			
			moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[5], newPosX+(horizontal*(a-1)), getUpDownY(posY, vertical*b));
			moSetGetOverlays.pda[whichSubPDA].design[5]:render();
						
			if not isHidden and ((g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) and not g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil)) or not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable)) and moSetGetOverlays.pda[whichSubPDA].keyControl and moSetGetOverlays.pda[whichSubPDA].keySelect.pda == 1 and moSetGetOverlays.pda[whichSubPDA].keySelect.line == b and moSetGetOverlays.pda[whichSubPDA].keySelect.app == a then
				moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[10], newPosX+(horizontal*(a-1)), getUpDownY(posY, vertical*b));
				moSetGetOverlays.pda[whichSubPDA].design[10]:render();
			end;			
		end;
	end;
	
	--test saveButton	
	--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["save"], newPosX+(horizontal*(appsAtMasterLine-0.5)), posY);
	--moSetGetOverlays.pda[whichSubPDA].design["save"]:render();	
	--test saveButton
	
	local tempViewLines = 1;	
	function setAppIcons(renderLine)
		if moSetGetOverlays.pda[whichSubPDA].line[renderLine].view and tempViewLines <= viewLines then			
			local buttonTable = nil;
			local selectSettingLine = 0;
			local appSettingSelect = 0;
			if moGeneralSettings.setMouseCursor then
				if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and #moSetGetOverlays.pda[whichSubPDA].line[renderLine].app > appsAtMasterLine then
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"], posX, getUpDownY(posY, vertical*(tempViewLines)));
					moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"]:render();									
					if not isHidden then 
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].width, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+(moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height/2), moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height, "lineLeft", renderLine, whichSubPDA);
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].width, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+(moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height/2), "lineRight", renderLine, whichSubPDA);
					end;
				end;
				--Setting Open Line
				if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then--guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then						
					local infoTxt = tostring(renderLine);
					local optiSize = moSetGetExtras:optiHeightSize(self, vertical, tostring(infoTxt), 0.009);
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], posX+width-(horizontal/2), getUpDownY(posY, vertical*(tempViewLines))+(vertical/2), horizontal/2, vertical/2);
					moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);
					moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], posX+width-(horizontal/2), getUpDownY(posY, vertical*(tempViewLines))+(vertical/2), horizontal/2, vertical/2);
					selectSettingLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
					if tonumber(selectSettingLine) == tonumber(renderLine) then
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, "lineSetting", renderLine, whichSubPDA);
					end;					
					if tonumber(selectSettingLine) == tonumber(renderLine) and not moSetGetExtras:runsTimer("1sec", true) then						
						moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();
					else 
						local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
						setTextColor(unpack(moColors.intern["mangenta"]));
						setTextBold(true);						
						setTextAlignment(1);						
						renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
						setTextAlignment(0);
						setTextBold(false);
						setTextColor(1, 1, 1, 1);
					end;
				end;
				--Setting open Line
			end;
			local viewAppIcon = 0;
			local appSelect = moSetGetOverlays.pda[whichSubPDA].line[renderLine].appSelect;
			if appSelect > 1 and moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine <= appsAtMasterLine then appSelect = 1;end;			
			appSettingSelect = moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app; --moSetGetOverlays.pda[whichSubPDA].line[renderLine].appSettingSelect;			
			for b=appSelect, moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine do				
				if viewAppIcon <= appsAtMasterLine then
					viewAppIcon = viewAppIcon+1;
					--Setting Open Apps 
					if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp > 0 then						
						local iconName = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconName;
						local iconTyp = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp;
						if moSetGetOverlays.appIcon[whichSubPDA][iconName] == nil then iconName = "mohIconFail_";iconTyp=1;end;
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
						moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
						if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
						else
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
						end;
						if iconTyp == 3 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color ~= nil then
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[3] then
								moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[1]);
							else
								moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[2]);
							end;
						elseif iconTyp == 4 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and string.len(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].txt) > 0 then
							setTextColor(unpack(moColors.intern["black"]));
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color ~= nil then setTextColor(unpack(moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})));end;
							--moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})
							local iconTxt = tostring(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].txt);
							local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2-(verticalTxtDistance), tostring(iconTxt), 0.015);
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size ~= nil then
								if optiSize > moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size then optiSize = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size;end;
							end;
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold ~= nil then
								setTextBold(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold);
							end;
							--local txtHeight = getTextHeight(optiSize, tostring(iconTxt));
							setTextWrapWidth(moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(horizontalTxtDistance));
							setTextLineBounds(0, 2);
							setTextAlignment(1);
							renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance, optiSize, tostring(iconTxt))
							setTextAlignment(0);
							setTextWrapWidth(0);
							setTextLineBounds(0, 0);
							setTextColor(1, 1, 1, 1);
							setTextBold(false);
						end;
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["openMarker"], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth+(horizontal-moSetGetOverlays.pda[whichSubPDA].design["openMarker"].width-distanceAppIconWidth), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							moSetGetOverlays.pda[whichSubPDA].design["openMarker"]:render();
						end;						
					end;
					if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp == 0 then
						local iconName = "mohIconBlank_";
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
						moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
						if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
						else
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
						end;
					end;
					if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then --guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);						
						if tonumber(appSettingSelect) == tonumber(b) and tonumber(selectSettingLine) == tonumber(renderLine) then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[11], newPosX+(horizontal*(viewAppIcon-1)), getUpDownY(posY, vertical*tempViewLines));
							moSetGetOverlays.pda[whichSubPDA].design[11]:render();
							--moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[11].x, moSetGetOverlays.pda[whichSubPDA].design[11].x+moSetGetOverlays.pda[whichSubPDA].design[11].width, moSetGetOverlays.pda[whichSubPDA].design[11].y, moSetGetOverlays.pda[whichSubPDA].design[11].y+moSetGetOverlays.pda[whichSubPDA].design[11].height, "appSetting", renderLine, whichSubPDA, b);
						end;
						if not moSetGetExtras:runsTimer("3sec", true) and tonumber(selectSettingLine) == tonumber(renderLine) then
							moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
							if tonumber(appSettingSelect) == tonumber(b) and not moSetGetExtras:runsTimer("1sec", true) then
								moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();
							else
								local infoTxt = tostring(b);
								local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
								setTextColor(unpack(moColors.intern["mangenta"]));
								setTextBold(true);						
								setTextAlignment(1);								
								renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
								setTextAlignment(0);
								setTextBold(false);
								setTextColor(1, 1, 1, 1);
							end;
						end;
					end;
					--Setting Open Apps
					if viewAppIcon >= appsAtMasterLine then break;end;
					--test
						
					--test
				end;
			end;
			if viewAppIcon < appsAtMasterLine and viewAppIcon < moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine then
				for b=1, moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine do					
					if viewAppIcon <= appsAtMasterLine then	
						--Setting Open Apps.						
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp > 0 then						
							local iconName = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconName;
							local iconTyp = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp;
							if moSetGetOverlays.appIcon[whichSubPDA][iconName] == nil then iconName = "mohIconFail_";iconTyp=1;end;
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
							if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
							else
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
							end;
							if iconTyp == 3 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color ~= nil then
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[3] then
									moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[1]);
								else
									moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[2]);
								end;
							elseif iconTyp == 4 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and string.len(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].txt) > 0 then
								setTextColor(unpack(moColors.intern["black"]));
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color ~= nil then setTextColor(unpack(moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})));end;
								--moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})
								local iconTxt = tostring(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].txt);
								local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2-(verticalTxtDistance), tostring(iconTxt), 0.015);
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size ~= nil then
									if optiSize > moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size then optiSize = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size;end;
								end;
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold ~= nil then
									setTextBold(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold);
								end;
								--local txtHeight = getTextHeight(optiSize, tostring(iconTxt));
								setTextWrapWidth(moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(horizontalTxtDistance));
								setTextLineBounds(0, 2);
								setTextAlignment(1);
								renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance, optiSize, tostring(iconTxt))
								setTextAlignment(0);
								setTextWrapWidth(0);
								setTextLineBounds(0, 0);
								setTextColor(1, 1, 1, 1);
								setTextBold(false);
							end;
							if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker then
								moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["openMarker"], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth+(horizontal-moSetGetOverlays.pda[whichSubPDA].design["openMarker"].width-distanceAppIconWidth), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
								moSetGetOverlays.pda[whichSubPDA].design["openMarker"]:render();
							end;
						end;
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp == 0 then
							local iconName = "mohIconBlank_";
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
							if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
							else
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
							end;
						end;						
						if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then --guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
							moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);							
							if tonumber(appSettingSelect) == tonumber(b) and tonumber(selectSettingLine) == tonumber(renderLine) then
								moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[11], newPosX+(horizontal*(viewAppIcon)), getUpDownY(posY, vertical*tempViewLines));
								moSetGetOverlays.pda[whichSubPDA].design[11]:render();
								--moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[11].x, moSetGetOverlays.pda[whichSubPDA].design[11].x+moSetGetOverlays.pda[whichSubPDA].design[11].width, moSetGetOverlays.pda[whichSubPDA].design[11].y, moSetGetOverlays.pda[whichSubPDA].design[11].y+moSetGetOverlays.pda[whichSubPDA].design[11].height, "appSetting", renderLine, whichSubPDA, b);
							end;
							if not moSetGetExtras:runsTimer("3sec", true) and tonumber(selectSettingLine) == tonumber(renderLine) then
								moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
								if tonumber(appSettingSelect) == tonumber(b) and not moSetGetExtras:runsTimer("1sec", true) then									
									moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();								
								else									
									local infoTxt = tostring(b);
									local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
									setTextColor(unpack(moColors.intern["mangenta"]));
									setTextBold(true);						
									setTextAlignment(1);
									renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
									setTextAlignment(0);
									setTextBold(false);
									setTextColor(1, 1, 1, 1);
								end;
							else
								--warning Icon Test
								--moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["red"]);
								--moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
								--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["warning"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2.5), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
								--moSetGetOverlays.pda[whichSubPDA].design["warning"]:render();
							end;
						end;
						--Setting Open Apps
						viewAppIcon = viewAppIcon+1;						
						if viewAppIcon >= appsAtMasterLine then break;end;
					else
						break;
					end;
				end;
			end;
			tempViewLines = tempViewLines+1;
		end;		
	end;
	if not isHidden then
		if moSetGetOverlays.pda[whichSubPDA].pos.up or posY >= 0.5 then
			for a=1, #moSetGetOverlays.pda[whichSubPDA].renderViewLines do
				setAppIcons(moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]);
			end;
		elseif not moSetGetOverlays.pda[whichSubPDA].pos.up or posY < 0.5 then
			for a=#moSetGetOverlays.pda[whichSubPDA].renderViewLines, 1, -1 do
				setAppIcons(moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]);
			end;
		end;
	end;	
	if moGeneralSettings.setMouseCursor and not isHidden then
		--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["setting"], newPosX-moSetGetOverlays.pda[whichSubPDA].design["setting"].width/2, posY);
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["setting"], posX, posY);
		moSetGetOverlays.pda[whichSubPDA].design["setting"]:render();		
		if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["setting"].x, moSetGetOverlays.pda[whichSubPDA].design["setting"].x+moSetGetOverlays.pda[whichSubPDA].design["setting"].width, moSetGetOverlays.pda[whichSubPDA].design["setting"].y, moSetGetOverlays.pda[whichSubPDA].design["setting"].y+moSetGetOverlays.pda[whichSubPDA].design["setting"].height, "pdaSetting", nil, whichSubPDA);end;
		--closeButton
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["close"], newPosX+(horizontal*appsAtMasterLine), posY);
		moSetGetOverlays.pda[whichSubPDA].design["close"]:render();	
		if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["close"].x, moSetGetOverlays.pda[whichSubPDA].design["close"].x+moSetGetOverlays.pda[whichSubPDA].design["close"].width, moSetGetOverlays.pda[whichSubPDA].design["close"].y, moSetGetOverlays.pda[whichSubPDA].design["close"].y+moSetGetOverlays.pda[whichSubPDA].design["close"].height,	"closePda", nil, whichSubPDA);end;
		--closeButton	
			
			
		if viewLines < #moSetGetOverlays.pda[whichSubPDA].line then			
			moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"], newPosX, getUpDownY(posY, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, vertical*viewLines));
			moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"]:render();			
			if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+(moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width/2), moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, "lineUp", nil, whichSubPDA);end;
			if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+(moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width/2), moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, "lineDown", nil, whichSubPDA);end;
		end;
		--scroll MasterPDA with mouse lines
		if not isHidden and moSetGetOverlays.pda[whichSubPDA].viewLines < #moSetGetOverlays.pda[whichSubPDA].line then
			moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[1].x+moSetGetOverlays.pda[whichSubPDA].design[1].width, moSetGetOverlays.pda[whichSubPDA].design[3].x, moSetGetOverlays.pda[whichSubPDA].design[7].y+moSetGetOverlays.pda[whichSubPDA].design[7].width+moSetGetOverlays.pda[whichSubPDA].design[7].height, moSetGetOverlays.pda[whichSubPDA].design[3].y, "scrollPDA", nil, whichSubPDA);
		end;		
		--scroll with mouse lines
	end;
	moSetGetOverlays.pda[whichSubPDA].width = width;
	moSetGetOverlays.pda[whichSubPDA].height = height;
	
	moDraw.mohPDA:clickAreas(self, posX, posX+width, posY-height, posY, "hiddenArea", nil, whichSubPDA);
	--moDraw.mohPDA:clickAreas(self, posX, posX+width, posY-height, posY, "totalPdaArea", nil, whichSubPDA); --free,later set global first check mouse at pda total or not 
	
	if not isHidden and g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then --and moSetGetExtras:getTimer(self, 0, true) then		
		local pdaName = moSetGetOverlays.pda[whichSubPDA].name or whichSubPDA;
		setTextBold(true);
		if posY-height > 0.06 then renderText(posX, posY-height-getTextHeight(0.0085, tostring(pdaName)), 0.0085, tostring(pdaName));
		elseif posY < 0.95 then renderText(posX, posY+verticalSmall, 0.0085, tostring(pdaName));end;
		setTextBold(false);
	end;	
end;

function getViewLine(self, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	local viewLine = 1;
	for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
		if moSetGetOverlays.pda[whichSubPDA].line[a] ~= nil then
			if moSetGetOverlays.pda[whichSubPDA].line[a].view then viewLine = a;break;end;
		end;
	end;
	return viewLine;
end;

function moDraw.mohPDA:clickAreas(self, posX, posX1, posY, posY1, whatClick, line, whereClick, appIcon, appIconName)
	local whichSubPDA = tostring(whereClick) or "masterPDA_";
	moGeneralSettings.clickAreas.pda[whichSubPDA][#moGeneralSettings.clickAreas.pda[whichSubPDA]+1] = {
		posX;
		posX1;
		posY;
		posY1;
		whatClick = tostring(whatClick) or "";
		line = line or 0;		
		whereClick = tostring(whereClick) or "";
		appIcon = appIcon or 0;
		appIconName = appIconName or "";
	};
	--moGeneralSettings.clickAreas.primarySlot[#moGeneralSettings.clickAreas.primarySlot+1] = {
	--	posX;
	--	posX1;
	--	posY;
	--	posY1;
	--	whatClick = tostring(whatClick) or "";
	--	line = line or 0;		
	--	whereClick = tostring(whereClick) or "";
	--	appIcon = appIcon or 0;
	--};
end;
